import IController, { AController } from './IController';
import IMark from './IMark';
declare class NullController extends AController {
    onMouseUpText(): void;
    onMouseUpMark(): void;
    onMouseUpSelection(): void;
    onMouseUpMetaString(): void;
    onMouseUpOther(): void;
}
declare class TextSelectionController extends AController {
    private deselectCbk;
    private selectNewCbk;
    private selectMarkCbk;
    constructor(deselectCbk: TextSelectionController['deselectCbk'], selectNewCbk: TextSelectionController['selectNewCbk'], selectMarkCbk: TextSelectionController['selectMarkCbk']);
    protected deselect(): void;
    protected selectNew(begChar: number, endChar: number): void;
    protected selectMarks(marks: IMark[]): void;
    onMouseUpText(e: Event, charRange: [number, number]): void;
    onMouseUpMark(e: Event, charRange: [number, number], marks: IMark[]): void;
    onMouseUpSelection(e: Event, charRange: [number, number]): void;
    onMouseUpMetaString(e: Event, charRange: [number, number], metaStringText: string): void;
    onMouseUpOther(e: Event): void;
}
declare class WordSelectionController extends TextSelectionController {
    onMouseUpText(e: Event, charRange: [number, number]): void;
}
export { IController, AController, NullController, TextSelectionController, WordSelectionController };
